.\" GNU groff interface for Bangla font
.\" By Muhammad A Muquit
.\" e-mail: muquit@semcor.com
.\" this document is written with mm macro using vi editor on a
.\" Sparc 10 running SunOS 4.1.4 anf groff 1.09
.\" to prepare the PostScript output, type:
.\" groff -t -mgm bangladoc.mm > bangladoc.ps
.\" print the postscript document in your PostScript printer
.\"
.\"
.de XS
.ft C
.ps 10
.nf
..
.de XE
.R
.fi
.ps 10
..
.\" underline macro
.de us
\\$1\l'|0\(ul'
..
.ND "Wednesday, September 21, 1994"
.COVER
.TL
GNU \fIgroff\fP interface for
.br
Bangla Font (SGAON)
.br
.AF "muquit@semcor.com"
.AU "Muhammad A. Muquit"
.MT 4
.ds HF 3 3 3 3 3 3 3
.AS
This document describes how \fIbangla\fP font is implemented with GNU
\fIgroff\fP software.  The \fIbangla\fP font \fIsgaon\fP is a HP Laserjet
softfont.  This font is developed by \fIAnisur Rahman\fP.  In this
implementation, the softfonts are converted to \fIPostScript\fP and the
\fIgroff\fP fonts are also generated from the \fIAdobe Font Matrics\fP,
\fIencoding\fP, and \fImap\fP files.  The reason for implementing fonts with
\fIgroff\fP is to take advantage of it's inherent document processing
power.  This document is prepared with \fIgroff\fP \fBmm\fP macros package
using the \fIvi\fP editor on a SPARC 10 running SunOS 4.1.4 and \fIgroff
1.09\fP.
.AE
.COVEND
.H 1 "GNU \fIgroff\fP Interface"
If you already have \fIgroff\fP and do not want to know bangla font is
implemented, please skip to section \fBInstalling Bangla Fonts\fP.
.P
GNU \fIgroff\fP software is freely available on Internet from
\fIprep.ai.mit.edu\fP.  The location is \fIpub/gnu/groff-1.09.tar.gz\fP. 
The current version of groff is 1.09.  It requires a C++ compiler to compile.
The \fIgroff\fP software is written by James Clark \fI(jjc@jclark.com)\fP.
.P
The \fIbangla\fP HP softfont file \fISGAON.ZIP\fP is available through
anonymous \fIftp\fP from various sites around the world.  After extracting the
files, the softfont is converted to \fIPostScript\fP.  This can be done with
the program supplied with \fISGAON\fP, HPTOPS.EXE or some other program freely
available on Internet, e.g., \fIpk2ps\fP available with \fIpsroff\fP software.
Let's say the \fIPostScript\fP font file name is \fBbangla10.pfa\fP.
The \fIAdobe Font Matrics\fP (AFM) file also needs to be generated.
HPTOPS.EXE can also generate AFM file for the same font.  
.P
Once the AFM file is generated, GNU \fIgroff\fP fonts can be generated with
the program \fIafmtodit\fP supplied with \fIgroff\fP software.  \fIaftodit\fP
is a perl script.  This program requires the encoding and map files for the
\fIPostScript\fP font.  
The encoding and map files have to generated by hand. 
.P
The encoding file consist of a sequence of the lines of the form:
.br
.sp
	\fIps_char code\fP
.sp
where \fIps_char\fP is the \fIPostScript\fP name of the character and
\fIcode\fP is it's position in the encoding expressed as a decimal integer.
The code for each character given in the font file must correspond to the code
for the character in the encoding file.
.P
The map should contain a sequence of lines of the form:
.br
.sp
	\fIps_char groff_char\fP
.sp
where \fIps_char\fP is the \fIPostScript\fP name of the character and
\fIgroff_char\fP is the groff name of the character (as used in the groff font
file).  Please look at \fIaftodit(1)\fP and \fIgrops(1)\fP man pages 
for details.
.P
Let's say, the encoding file name is \fBbangla.enc\fP.
After generating the GNU
\fIgroff\fP font, (let's say the name of the font is \fBBNG10\fP), follow the
steps:
.AL
.LI
copy GNU \fIgroff\fP font file \fBBNG10\fP file to
\fB/usr/local/lib/groff/font/devps\fP.  
.LI
copy the encoding file \fBbangla.enc\fP to 
\fB/usr/local/lib/font/groff/devps\fP.
.LI
copy the \fIPostScript\fP font file \fBbangla10.pfa\fP to
\fB/usr/local/lib/groff/devps\fP.
.LI
edit the file \fB/usr/local/lib/font/groff/devps/download\fP, and put an entry
like this:
.sp
Bangla-Sgaon10      bangla10.pfa
.sp
where \fBBangla-Sgaon10\fP is the \fIPostScript\fP font name and
\fIbangla10.pfa\fP is the name of the \fIPostScript\fP file.
.LE
.P
Once the above steps are followed, you are done with installing \fIbangla\fP font
with \fIgroff\fP.  Now the font can be accessed from any macro e.g., \fImm,
ms, me\fP.  You only can install font this way if you have \fIroot\fP access.
\fBThe bangla font CAN be used if you do not have \fIroot\fP access\fP.  
.R
Please look at the section \fBInstalling Bangla Fonts\fP for details.
.P
Fortunately, you do not have to do many of the things mentioned above. I
already generated the \fIPostScript\fP, GNU \fIgroff\fP fonts, and the
encoding file.  So, you only have to copy these files to the place described
above.  Please look at the \fBInstalling Bangla Fonts\fP section for the exact
steps you have to follow.
.bp
.H 2 "Installing Bangla Fonts"
.H 2 "You DO NOT Have root Aceess"
You are looking at this document, so you must have extracted the necessary
files from the \fIshar\fP archive.  The extraction procedure will place the
fonts and necessary files at the correct hierarchy.  You only have to set a
environment variable called \fBGROFF_FONT_PATH\fP, and you \fBmust\fP do it.
.P
If your shell is \fIcsh, tcsh\fP or a variant of \fIcsh\fP,  set the
environment variable like this:
.sp
\fBsetenv GROFF_FONT_PATH $HOME/bangla_font\fP
.P
You can put it in your \fI.cshrc\fP file, so you will not have to type it all
the time.
.P
If you are using \fIsh, bash\fP or a variant of \fIsh\fP, set the
environment variable like this:
.sp
.nf
.B
GROFF_FONT_PATH=$HOME/bangla_font
export GROFF_FONT_PATH
.R
.fi
.P
You can put these line in your \fI.profile\fP for permanent use.
.P
.B
.us "NOTE:" 
.R
I am assuming \fIbangla_font\fP directory is located at your
\fBhome\fP directory.  If it is somewhere else, use the correct path.
.sp
.H 2 "You Have root Access"
If you do not have root access or do not wish to install bangla fonts as
\fIroot\fP, you can skip to the next section.  The advantage of installing
fonts as root is that everyone will have access to the fonts without doing
anything special.
.P
\fBIf you have root access\fP, change directory to \fCbangla_font/devps\fP (If you are already not there), then
follow these steps:
.XS
.AL
.LI
/bin/cp ./BNG10 /usr/local/lib/groff/font/devps
.LI
/bin/cp ./BNG10i /usr/local/lib/groff/font/devps
.LI
/bin/cp ./bangla10.pfa /usr/local/lib/groff/font/devps
.LI
/bin/cp ./bangla10i.pfa /usr/local/lib/groff/font/devps
.LI
/bin/cp ./bangla.enc /usr/local/lib/groff/font/devps
.LI
edit the file \fB/usr/local/lib/groff/font/devps/download\fP and put two
entries at the end of the file like this:
.sp
Bangla-Sgaon10      bangla10.pfa
Bangla-Sgaon10i     bangla10i.pfa
.LE
.XE
.AE
.P
.nf
where, 
	   \fCBNG10\fP is the groff font file (10 point normal),
       \fCBNG10i\fP is the groff font file (10 point italic),
       \fCbangla10.pfa\fP is the PostScript font file (10 point normal),
       \fCbangla10i.pfa\fP is the PostScript font file (10 point italic),
       \fCbangla.enc\fP is the encoding file.
.fi
.P
.B
.us "NOTE:"
.R
the standard location of \fIPostScript\fP fonts for \fIgroff\fP is
\fC/usr/local/lib/groff/font/devps\fP, if it is different in your
machine, please use that location instead.
.bp
.H 1 "Keyboard Mapping"
The layout of a Sun Type 5 keyboard is shown in Figure 1 and the corresponding
mapping among english and bangla characters are shown in Figure 2. The
characters shown on the keyboard can be typed directly as shown.  Please look
at section \fBHigher ASCII assignment\fP to access compound characters
(\f[BNG10]ju\N'167'ACr\fP).
.PSPIC ./sunkeyb.eps
.FG "Sun \fIType 5\fP Keyboard Layout"
.P
The equivalent map among english and bangla characters are shown in Figure
2.
.PSPIC ./sunkeybB.eps
.FG "Map Among English and Bangla Characters"
.bp
.H 1 "Higer ASCII assignment"
As shown in Figure 2, 94 bangla characters are mapped to the main keyboard,
that means, those characters can be typed directly from the keyboard.  The rest
of the characters are mapped to \fBASCII\fP decimal codes from 161-209.  
The characters mapped from \fBASCII\fP 161-209 have to be accessed by their
code.  The following tables shows the higher ASCII assignment of the \fIbangla\fP
characters.  Please look at the section \fBHow to Access Compound Characters\fP
to know how to use them.
.ft AR
.br
.ce 1
\fBHigher ASCII assignment for Bangla font [10 pt]\fP
.DS
.TS
box, center tab(;);
cb s s s s s
c | c | c | c | c | c
l | l | l | l | l | l.
ASCII Assignment
_
Decimal;Character;Decimal;Character;Decimal;Character
_
.ft BNG10
.ps 10
161;\N'161';162;\N'162';163;\N'163'
164;\N'164';165;\N'165';166;\N'166'
167;\N'167';168;\N'168';169;\N'169'
170;\N'170';171;\N'171';172;\N'172'
173;\N'173';174;\N'174';175;\N'175'
176;\N'176';177;\N'177';178;\N'178'
179;\N'179';180;\N'180';181;\N'181'
182;\N'182';183;\N'183';184;\N'184'
185;\N'185';186;\N'186';187;\N'187'
188;\N'188';189;\N'189';190;\N'190'
191;\N'191';192;\N'192';193;\N'193'
194;\N'194';195;\N'195';196;\N'196'
197;\N'197';198;\N'198';199;\N'199'
200;\N'200';201;\N'201';202;\N'202'
203;\N'203';204;\N'204';205;\N'205'
206;\N'206';207;\N'207';208;\N'208'
209;\N'209';
.TE
.DE
.H 2 "How to Access Compound Charcaters"
In \fIgroff\fP, the special characters can be accessed by their code. As for
example to access bangla \f[BNG10]\N'198'\fP, you access the character by
it's code like this: \e N\'198\'.  You have to be careful about one thing here
if you are not a veteran \fIroff\fP user.  If you have selected an english
font before e.g. \"Times-Roman\" using .R, if you want to access a \fBbangla\fP
character in the middle of \fBenglish\fP text, you have to change font to
bangla. As for example, to access \f[BNG10]\N'165'\fP in the middle of english as
you are seeing here you have to change font to bangla like this: \e f[BNG10]\e
N\'165\'\e fP.  \e fP will change back to the font whatever font you were using
before.
.bp
.H 1 "Example"
.nf
Input text:
.ft C
.sp
\&.ft BNG10
bA\\\\lA<dS
\&.R
bA\\\\lA<dS
.br
.sp
will produce out put:
.sp
.fi
.ft BNG10
bA\\lA<dS
.R
bA\\lA<dS
.nf
.sp
Also,
\e f[BNG10]bA\\\\lA<dS\e fP bA\\\\lA<dS
.sp
will produce the same output:
.sp
\f[BNG10]bA\\lA<dS\fP bA\\lA<dS
.fi
.P
Now you know how to use bangla and english fonts together. The following
examples show the input and bangla output:
.P
The following table shows many examples of english input and bangla output.
.P
.TS H
box, center tab(;);
C  S
l | l.
Examples
=
.TH
\e N\'208'<k^Sl;\f[BNG10]\N'208'<k^Sl\fP
_
k\e N\'174\'pYtAr;\f[BNG10]ki\N'174'pYtAr\fP
_
ju\e N\'167\'b\e N\'193\';\f[BNG10]ju\N'167'bN\N'193'\fP
_
a\e N\'161\'l;\f[BNG10]a\N'161'l\fP
_
xAMd;\f[BNG10]xAMd\fP
_
gu\e N\'163\'n;\f[BNG10]gu\N'163'n\fP
_
H\e N\'164\'A;\f[BNG10]H\N'164'A\fP
_
b\e N\'165\';\f[BNG10]b\N'165'\fP
_
l\e N\'170\'\e N\'190\';\f[BNG10]l\N'170'\N'190'\fP
_
\e N\'209\'hn;\f[BNG10]\N'209'hn\fP
_
\e N\'203\'\e N\'169\';\f[BNG10]\N'203'\N'169'\fP
_
isi\e N\'173\'dkI;\f[BNG10]isi\N'173'dkI\fP
_
<mAhA\e N\'174\'md;\f[BNG10]<mAhA\N'174'md\fP
_
k<\e N\'186\'lAl;\f[BNG10]k<\N'186'lAl\fP
_
a\e N\'200\';\f[BNG10]a\N'200'\fP
_
aA\e N\'184\'bA;\f[BNG10]aA\N'184'bA\fP
_
Y\e N\'182\'\e N\'190\'q;\f[BNG10]Y\N'182'\N'190'q\fP
_
Y\e N\'182\'mAd;\f[BNG10]Y\N'182'mAd\fP
_
ib@An;\f[BNG10]ib@An\fP
_
Y\e N\'185\'xqA;\f[BNG10]Y\N'185'xqA\fP
_
ibh\e N\'184\'l;\f[BNG10]ibh\N'184'l\fP
_
b>AW;\f[BNG10]b>AW\fP
_
\e N\'206\'m;\f[BNG10]\N'206'm\fP
_
x\e N\'196\';\f[BNG10]x\N'196'\fP
_
x\e N\'200\'\e N\'209\'Am;\f[BNG10]x\N'200'\N'209'Am\fP
_
aCr;\f[BNG10]aCr\fP
.TE
.H 1 "Copyright"
My employer \fBSEMCOR, Inc.\fP has nothing to do with this implementation of
bangla font with \fIgroff\fP.  This work is done over few weekends and in my
own time.  I disclaim all warranties with regard to this implementation,
including all implied warranties of merchantability and fitness, in no
event shell me or my employer SEMCOR, Inc. be liable for any special,
indirect or consequential damages or any damages whatsoever resulting from
loss of use, data or profits, whether in an action of contract, negligence
or other tortious action, arising out of or in connection with the use or
performance of this implementation of bangla font.

.H 1 "Acknowledgment"
Thanks to Dr. Anisur Rahman\(dg
.FS \(dg
Email: \fI??\fP
.FE
for his SGAON font. Without his font this work
would not be possible. Thanks to Dr. Shameem Siddiqui\(dd
.FS \(dd
Email: \fIshameem@pnge.psu.edu\fP
.FE
for suggesting many things and encouraging me to implement bangla font with \fIgroff\fP.
.P
If you have any problem with installing fonts, you are welcome to send me
e-mail.
.sp
.nf
Muhammad A Muquit
Software Development Group \fI[X,Motif]\fP,
Tactical Information Systems.
SEMCOR, Inc.
65 West Street Road
Warminster, PA 18974
\fBE-mail:\fP \fImuquit@semcor.com\fP
.fi
.TC
